"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactJss = require("react-jss");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _default = function _default(_ref) {
  var _ref$providerProps = _ref.providerProps,
      providerProps = _ref$providerProps === void 0 ? {} : _ref$providerProps;
  return {
    beforeRenderToElement: function beforeRenderToElement(App, _ref2) {
      var meta = _ref2.meta;
      return function (props) {
        // Create a sheetsRegistry instance.
        meta.jssSheetsRegistry = new _reactJss.SheetsRegistry(); // TODO we could actually add the style removal here too in a componentDidMount:
        // https://github.com/cssinjs/examples/blob/gh-pages/react-ssr/src/client.js

        return /*#__PURE__*/_react["default"].createElement(_reactJss.JssProvider, _extends({}, providerProps, {
          registry: meta.jssSheetsRegistry
        }), /*#__PURE__*/_react["default"].createElement(App, props));
      };
    },
    headElements: function headElements(elements, _ref3) {
      var meta = _ref3.meta;
      return [].concat(_toConsumableArray(elements), [/*#__PURE__*/_react["default"].createElement("style", {
        id: "jss-server-side",
        dangerouslySetInnerHTML: {
          __html: meta.jssSheetsRegistry.toString()
        }
      })]);
    }
  };
};

exports["default"] = _default;